package com.skica.spvbpisvsportalbackend.controller;

import com.skica.spvbpisvsportalbackend.entity.OrganisationItSystem;
import com.skica.spvbpisvsportalbackend.repository.OrganisationItSystemRepository;
import jakarta.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

@Controller
@RequestMapping("/svc/organisation-it-system")
public class OrganisationItSystemController {
    @Autowired
    private OrganisationItSystemRepository organisationItSystemRepository;


    @PostMapping(value="/create", consumes = MediaType.APPLICATION_FORM_URLENCODED_VALUE)
    public String save(final @ModelAttribute("createOrganisationItSystem") OrganisationItSystem organisationItSystem,
                       final BindingResult bindingResult,
                       final HttpServletRequest httpServletRequest) {
        if (bindingResult.hasErrors()) {
            throw new RuntimeException(String.valueOf(bindingResult.getAllErrors()));
        }
        if(organisationItSystem.code != null && !organisationItSystem.code.isEmpty()) {
            organisationItSystemRepository.save(organisationItSystem);
        }


        return "redirect:" + httpServletRequest.getHeader(HttpHeaders.REFERER);
    }
    @PostMapping({"/delete/{entityId}"})
    public String delete(@PathVariable("entityId") String entityId, final HttpServletRequest httpServletRequest) {
        organisationItSystemRepository.deleteById(entityId);
        return "redirect:" + httpServletRequest.getHeader(HttpHeaders.REFERER);
    }
}
