package com.skica.spvbpisvsportalbackend.controller;

import com.skica.spvbpisvsportalbackend.entity.OrganisationItSystem;
import com.skica.spvbpisvsportalbackend.entity.OrganisationRoom;
import com.skica.spvbpisvsportalbackend.repository.OrganisationItSystemRepository;
import com.skica.spvbpisvsportalbackend.repository.OrganisationRoomRepository;
import jakarta.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;

@Controller
@RequestMapping("/svc/organisation-room")
public class OrganisationRoomController {
    @Autowired
    private OrganisationRoomRepository organisationRoomRepository;


    @PostMapping(value="/create", consumes = MediaType.APPLICATION_FORM_URLENCODED_VALUE)
    public String save(final @ModelAttribute("createOrganisationRoom") OrganisationRoom organisationRoom,
                       final BindingResult bindingResult,
                       final HttpServletRequest httpServletRequest) {
        if (bindingResult.hasErrors()) {
            throw new RuntimeException(String.valueOf(bindingResult.getAllErrors()));
        }
        if(organisationRoom.code != null && !organisationRoom.code.isEmpty()) {
            organisationRoomRepository.save(organisationRoom);
        }

        return "redirect:" + httpServletRequest.getHeader(HttpHeaders.REFERER);
    }
    @PostMapping({"/delete/{entityId}"})
    public String delete(@PathVariable("entityId") String entityId, final HttpServletRequest httpServletRequest) {
        organisationRoomRepository.deleteById(entityId);
        return "redirect:" + httpServletRequest.getHeader(HttpHeaders.REFERER);
    }
}
