package com.skica.spvbpisvsportalbackend.controller.unused;

import com.skica.spvbpisvsportalbackend.Common;
import com.skica.spvbpisvsportalbackend.entity.unused.Asset;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

@Controller
@RequestMapping("/asset")
public class AssetController {
    @Autowired
    private SessionFactory sessionFactory;

    @GetMapping({"/view/{entityId}"})
    public String view(@PathVariable("entityId") int entityId, Model model) {
        try (var session = sessionFactory.openSession()) {
            model.addAttribute("asset", session.get(Asset.class, entityId));
        }
        return "view/asset";
    }

    @GetMapping({"/list"})
    public String list(Model model) {
        model.addAttribute("assets", Common.getEntities(sessionFactory, Asset.class));
        return "entity/list/asset.html";
    }

    @GetMapping({"/create"})
    public String create(ModelMap model) {
        model.addAttribute("asset", new Asset());
        return "entity/create/asset.html";
    }

    @PostMapping(value="/create")
    public String save(
            @ModelAttribute("asset") final Asset entity, final BindingResult bindingResult, final ModelMap model) {
        if (bindingResult.hasErrors()) {
            return "/";
        }
        try (var session = sessionFactory.openSession()) {
            var tx = session.beginTransaction();
            session.persist(entity);
            tx.commit();
        }
        model.clear();
        return "redirect:/asset/view/" + entity.name;
    }
}
