package com.skica.spvbpisvsportalbackend.entity;

import com.skica.spvbpisvsportalbackend.entity.business.BusinessProcess;
import jakarta.persistence.*;

import java.util.List;

@Entity
@Table(name = "organisation_application")
public class OrganisationApplication {
    @Id
    public String code;

    public String name;
    public String description;
    public Integer count;
    public String users;
    public String responsible;


    // @JsonIgnoreProperties("employees")
    @ManyToMany(fetch = FetchType.EAGER)
    @JoinTable(name = "organisation_application_business_process",
            joinColumns = @JoinColumn(name = "organisation_application", unique = false),
            inverseJoinColumns = @JoinColumn(name = "business_process", unique = false))
    public List<BusinessProcess> presentInBusinessProcesses;

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Integer getCount() {
        return count;
    }

    public void setCount(Integer count) {
        this.count = count;
    }

    public String getUsers() {
        return users;
    }

    public void setUsers(String users) {
        this.users = users;
    }

    public String getResponsible() {
        return responsible;
    }

    public void setResponsible(String responsible) {
        this.responsible = responsible;
    }
}
