package com.skica.spvbpisvsportalbackend.entity.business;

import com.skica.spvbpisvsportalbackend.enums.BasicProtectionValue;
import com.skica.spvbpisvsportalbackend.generic.GenericEntity;
import jakarta.persistence.*;

import java.util.List;

@Entity
public class BusinessProcess extends GenericEntity {

    @Column(nullable = false)
    public String name;

    public String owner;
    public String processedInformation;


    // Should be exactly three
    @OrderColumn
    @OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    public List<DescribedProtection> describedProtection;

    public Boolean isMain;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getOwner() {
        return owner;
    }

    public void setOwner(String owner) {
        this.owner = owner;
    }

    public String getProcessedInformation() {
        return processedInformation;
    }

    public void setProcessedInformation(String processedInformation) {
        this.processedInformation = processedInformation;
    }

    public DescribedProtection getDescribedProtection(BasicProtectionValue value) {
        var optionalDescribedProtection = describedProtection.stream().filter(dp -> dp.value == value).findFirst();

        if(optionalDescribedProtection.isEmpty()) {
            var dp = new DescribedProtection(value);
            describedProtection.add(dp);
            return dp;
        }

        return optionalDescribedProtection.get();
    }
    public List<DescribedProtection> getDescribedProtection() {
        return describedProtection;
    }

    public void setDescribedProtection(List<DescribedProtection> describedProtection) {
        this.describedProtection = describedProtection;
    }
    public Boolean getMain() {
        return isMain;
    }

    public void setMain(Boolean main) {
        isMain = main;
    }
}