package com.skica.spvbpisvsportalbackend.entity.unused;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.skica.spvbpisvsportalbackend.generic.GenericEntity;
import jakarta.persistence.*;

import java.util.Set;

@Entity
@Table(name="role")
public class Role extends GenericEntity {
    @Column(nullable = false)
    public String name;

    @JsonIgnoreProperties("roles")
    @ManyToMany(mappedBy = "roles", fetch = FetchType.EAGER)
    public Set<Employee> employees;

    public static final String ISO_NAME = "ISO";

    public Role() {}
    public Role(Long id) {
        this.id = id;
    }

    public static Role ISO() {
        Role roleIso = new Role();
        roleIso.name = ISO_NAME;
        return roleIso;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Set<Employee> getEmployees() {
        return employees;
    }

    public void setEmployees(Set<Employee> employees) {
        this.employees = employees;
    }
}
